/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/

//{TvvOł́AlTXDSPCugpĂ܂
//{Tvrhۂɂ́A
//vWFNgtH_ȉ
//(RX65_SOUND_EFFECTOR_FFT\lib\dsplib-rxv2)
//tH_ɁAlTXWeb_E[h\ȃlTXDSPCu(an-r01an4359jj0100-rx-dsplib)Ɋ܂܂
//dsplib-rxv2 ȉ̃t@CRs[Ă
//gpĂt@C͈ȉł
//r_dsp_typedefs.h
//r_dsp_types.h
//r_dsp_transform.h
//RX_DSP_FPU_LE_Check.lib
//iRXv2ALittleEndian, FPUgpj

//INBUF_UNIT_SIZE  512 (=FFT_SAMPLING_DATA_NUM /2) ɐݒ肵Ăisound_effector_userdef.hj


//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "sound_effector.h"
#include "r_dsp_typedefs.h"
#include "r_dsp_types.h"
#include "r_dsp_transform.h"

//njOgp
#define USE_HANNING_WINDOW

//FFT̃TvO
#define FFT_SAMPLING_DATA_NUM (1024)


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{

	unsigned long prev_inbuf_wp;
	
	long inbuf_index;
	
	pcm_data pcm_tmp;
	
	float data_tmp_ch0, data_tmp_ch1;
	
	float volume1_val;
	
	unsigned short i;

	//f[^obt@staticŊmۂ
	//staticɂȂꍇ́A[UX^bNɊmۂ邽߁AX^bNTCY0x10000xKv܂
	
	static float fft_input_ch0[FFT_SAMPLING_DATA_NUM];							//time-domain, FFT̓f[^
	static float fft_input_ch1[FFT_SAMPLING_DATA_NUM];

	static float prev_output_data_ch0[FFT_SAMPLING_DATA_NUM/2];					//1OIFFT
	static float prev_output_data_ch1[FFT_SAMPLING_DATA_NUM/2];
	
	static cplxf32_t fft_output_ch0[FFT_SAMPLING_DATA_NUM/2];					//frequency-domain, FFTo̓f[^
	static cplxf32_t fft_output_ch1[FFT_SAMPLING_DATA_NUM/2];
	
	static float ifft_output_ch0[FFT_SAMPLING_DATA_NUM];						//time-domain, IFFTo̓f[^
	static float ifft_output_ch1[FFT_SAMPLING_DATA_NUM];
	
	static vector_t vtime_ch0 = {FFT_SAMPLING_DATA_NUM, (void *)fft_input_ch0};
	static vector_t vtime_ch1 = {FFT_SAMPLING_DATA_NUM, (void *)fft_input_ch1};
	
	static vector_t vfreq_ch0 = {FFT_SAMPLING_DATA_NUM/2, (void *)fft_output_ch0};
	static vector_t vfreq_ch1 = {FFT_SAMPLING_DATA_NUM/2, (void *)fft_output_ch1};
	
	static vector_t vtime2_ch0 = {FFT_SAMPLING_DATA_NUM, (void *)ifft_output_ch0};
	static vector_t vtime2_ch1 = {FFT_SAMPLING_DATA_NUM, (void *)ifft_output_ch1};

	static cplxf32_t fft_twiddles1[FFT_SAMPLING_DATA_NUM + FFT_SAMPLING_DATA_NUM/2];
	static uint32_t fft_bitrev1[240];      											//1024 point̃obt@TCY

#ifdef USE_HANNING_WINDOW
	static float window[FFT_SAMPLING_DATA_NUM];										//֐
#endif

	static cplxf32_t fft_twiddles2[FFT_SAMPLING_DATA_NUM + FFT_SAMPLING_DATA_NUM/2];
	static uint32_t fft_bitrev2[240];   											//1024 point̃obt@TCY
	
#ifdef USE_HANNING_WINDOW
	static r_dsp_fft_t h1 = {FFT_SAMPLING_DATA_NUM, 0, fft_twiddles1, fft_bitrev1, NULL, window};		//FFT ֐܂߂
#else
	static r_dsp_fft_t h1 = {FFT_SAMPLING_DATA_NUM, 0, fft_twiddles1, fft_bitrev1, NULL, NULL};			//FFT ֐gȂ
#endif

	static r_dsp_fft_t h2 = {FFT_SAMPLING_DATA_NUM, 0, fft_twiddles2, fft_bitrev2, NULL, NULL};			//IFFT
	
	r_dsp_status_t sts1 = R_DSP_STATUS_OK;			//FFT
	r_dsp_status_t sts2 = R_DSP_STATUS_OK;			//IFFT
	r_dsp_status_t sts1_ch0 = R_DSP_STATUS_OK;		//FFT
	r_dsp_status_t sts1_ch1 = R_DSP_STATUS_OK;
	r_dsp_status_t sts2_ch0 = R_DSP_STATUS_OK;		//IFFT
	r_dsp_status_t sts2_ch1 = R_DSP_STATUS_OK;
	
	/* initialize required buffer sizes for twiddles etc. */
	size_t ntwb1; // bytes for twiddle array
	size_t nbrb1; // bytes for bit-reverse table
	size_t nwkb1; // bytes for working area	
	
	size_t ntwb2; // bytes for twiddle array
	size_t nbrb2; // bytes for bit-reverse table
	size_t nwkb2; // bytes for working area	
	
	//1OIFFTʂ̏
	for(i = 0; i < (FFT_SAMPLING_DATA_NUM / 2); i++)
	{
		prev_output_data_ch0[i] = 0;
		prev_output_data_ch1[i] = 0;
	}

#ifdef USE_HANNING_WINDOW
	//֐` njO
	for(i=0; i<FFT_SAMPLING_DATA_NUM; i++)	//FFT_SAMPLING_DATA_NUM͋
	{
		window[i] = 0.5 - 0.5 * cosf(2.0 * M_PI * ((float)i/(float)FFT_SAMPLING_DATA_NUM));
	}
#endif
	
	//FFT\̏
	sts1 = R_DSP_FFT_BufSize_f32cf32(&h1, &ntwb1, &nbrb1, &nwkb1);
	
	if((sizeof(fft_twiddles1) < ntwb1) || (sizeof(fft_bitrev1) < nbrb1))	//sizeof(fft_twiddles1)=12,288, ntwb1=6,144 cKv̔{mۂĂH//sizeof(fft_bitrev1)=960, nbrb1=960
	{
		while(1); /* not enough memory size */
	}
	
	sts1 = R_DSP_FFT_Init_f32cf32(&h1);
	
	//IFFT\̏
	sts2 = R_DSP_FFT_BufSize_cf32f32(&h2, &ntwb2, &nbrb2, &nwkb2);
	
	if((sizeof(fft_twiddles2) < ntwb2) || (sizeof(fft_bitrev2) < nbrb2))
	{
		while(1); /* not enough memory size */
	}
	
	sts2 = R_DSP_FFT_Init_cf32f32(&h2);
	
	//֐
	sound_effector_init();
	
	//Jn
	sound_effector_start();
	
	prev_inbuf_wp = 0;

	while(1)
	{
		
		if(g_sw_state == 0)
		{
			//X[iVR1ŉʒj
			volume1_val = (float)g_ad_val[0] / 4096.0;		//{[l𐳋K(0 ` 1)
			
			if(prev_inbuf_wp != g_inbuf_wp)
			{
#ifdef DEBUG_PORT
				P26 = 1;
#endif
				for(i=0; i<INBUF_UNIT_SIZE; i++)
				{
					
					data_tmp_ch0 = (float)g_inbuf[prev_inbuf_wp + i].ch0 / 32768.0; 	//͒l𐳋K(-1 ` 1)
					data_tmp_ch1 = (float)g_inbuf[prev_inbuf_wp + i].ch1 / 32768.0;
				
					data_tmp_ch0 *= volume1_val;			//{[lZ
					data_tmp_ch1 *= volume1_val;
					
					//NbsO
					pcm_tmp = clipping_data_norm(data_tmp_ch0, data_tmp_ch1);
				
					//o̓obt@Ɋi[
					put_data(pcm_tmp);
				}
				prev_inbuf_wp = g_inbuf_wp;
				
#ifdef DEBUG_PORT
				P26 = 0;
#endif

#ifdef DEBUG
				g_err_led_patturn = LED_OFF;
#endif
			}
		}
		else
		{
			//FFT
			if(prev_inbuf_wp != g_inbuf_wp)
			{
#ifdef DEBUG_PORT
				P27 = 1;
#endif		
				//1 (-512)-511̃f[^, _~[
				//2 0-1023f[^
				//3 512-1535̃f[^
				//4 1024-2047̃f[^
				//512I[obvăf[^
				
				//̓f[^FFT\̓̔zϐɃRs[
				for(i = 0; i < FFT_SAMPLING_DATA_NUM; i++)
				{
					//̎_ŁAinbuf_wp(=prev_inbuf_wp + (FFT_SAMPLING_DATA_NUM / 2))܂ł
					//̓f[^i[ς
					//prev_inbuf_wp - (FFT_SAMPLING_DATA_NUM / 2) ` prev_inbuf_wp - (FFT_SAMPLING_DATA_NUM / 2) + FFT_SAMPLING_DATA_NUM
					//iprev_inbuf_wp-512 `@prev_inbuf_wp+512(=inbuf_wp) ͈̔͂̃f[^ǂݍގ͖肪Ȃ
					
					inbuf_index = prev_inbuf_wp - (FFT_SAMPLING_DATA_NUM / 2) + i;
					if(inbuf_index < 0) inbuf_index += INBUF_SIZE;
					else if(inbuf_index >= INBUF_SIZE) inbuf_index -= INBUF_SIZE;
					
					fft_input_ch0[i] = (float)g_inbuf[inbuf_index].ch0 / 32768.0;
					fft_input_ch1[i] = (float)g_inbuf[inbuf_index].ch1 / 32768.0;
				}
				
				//FFT vtime -> vfreq, ԗ̈悩g̈ɕϊ
				sts1_ch0 = R_DSP_FFT_f32cf32(&h1, &vtime_ch0, &vfreq_ch0);
				sts1_ch1 = R_DSP_FFT_f32cf32(&h1, &vtime_ch1, &vfreq_ch1);
				
				//IFFT vfreq -> vtime2, g̈悩玞ԗ̈ɋtϊ
				sts2_ch0 = R_DSP_IFFT_CCS_cf32f32(&h2, &vfreq_ch0, &vtime2_ch0);
				sts2_ch1 = R_DSP_IFFT_CCS_cf32f32(&h2, &vfreq_ch1, &vtime2_ch1);
				
				//IFFTʂ̘A
				for(i = 0; i < (FFT_SAMPLING_DATA_NUM / 2); i++)
				{
					//O512f[^́AỎZʂƉZďo̓obt@Ɋi[
					
					data_tmp_ch0 = (prev_output_data_ch0[i] + ifft_output_ch0[i]);
					data_tmp_ch1 = (prev_output_data_ch1[i] + ifft_output_ch1[i]);
					
					//NbsO
					pcm_tmp = clipping_data_norm(data_tmp_ch0, data_tmp_ch1);
					
					put_data(pcm_tmp);
				}
				
				for(i = 0; i < (FFT_SAMPLING_DATA_NUM / 2); i++)
				{
					//㔼512f[^́AϐɈꎞۑ
					prev_output_data_ch0[i] = ifft_output_ch0[i + (FFT_SAMPLING_DATA_NUM / 2)];
					prev_output_data_ch1[i] = ifft_output_ch1[i + (FFT_SAMPLING_DATA_NUM / 2)];
				}
			
				prev_inbuf_wp = g_inbuf_wp;
				
#ifdef DEBUG_PORT
				P27 = 0;
#endif

#ifdef DEBUG
				//ErrLEDu点
				g_err_led_patturn = 0x00000001;
#endif
			}
		}

	}//while
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
